
/*
 *  FSEEK.C
 *
 *  (c)Copyright 1990, Matthew Dillon, All Rights Reserved
 */

#include <stdio.h>

int
fseek(fi, offset, how)
FILE *fi;
long offset;
int how;
{
    if (fi->sd_Flags & __SIF_APPEND) {  /*  fseek() illegal */
	fi->sd_Error = EOF;
	return(EOF);
    }

    fflush(fi);
    fi->sd_Offset = lseek(fi->sd_Fd, offset, how);
    if (fi->sd_Offset < 0)
	fi->sd_Error = EOF;
    fi->sd_Flags &= ~__SIF_EOF;
    return(fi->sd_Error);
}

